Subject: Re: Paper cut bug: Why isn't "git clone xxxx" recursive by default?

From: Junio C Hamano <[email-masked]>
Date: Tue, 03 Jun 2014 12:52:25 -0700

Mara Kim <[email-masked]> writes:

> Apologies if this question has been asked already, but what is the
> reasoning behind making git clone not recursive (--recursive) by
> default?

The primary reason why submodules are separate repositories is not
to require people to have everything.  Some people want recursive,
some others don't, and the world is not always "majority wins" (not
that I am saying that majority will want recursive).

Inertia, aka backward compatibility and not surprising existing
users, plays some role when deciding the default.

Also, going --recursive when the user did not want is a lot more
expensive mistake to fix than not being --recursive when the user
wanted to.